/*
 * Copyright (C) 2007 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.black3r.bakalarka.bakalarka;

// Wrapper for native library

public class JNILib {

    static {
        System.loadLibrary("bakalarka");
    }

    public static int error = 47;

    public static native void createFile();

    public static native long[] getattr(String file);
    public static native long[] statfs(String file);


    public static native int open(String path, int flags);
    public static native int access(String path, int flags);
    public static native byte[] read(int fd, int size, int offset);
    public static native int write(int fd, byte[] buffer, int size, int offset);

    public static native int create(String path, int mode);
    public static native int unlink(String path);
    public static native int rmdir(String path);
    public static native int mkdir(String path, int mode);
    public static native int close(int fd);
    public static native int truncate(String path, int offset);

    public static native int rename(String oldpath, String newpath);

    public static native int fallocate(int fd, int mode, int offset, int length);
    public static native int futimens(String path, int sec0, int nsec0, int sec1, int nsec1);
}
