package net.black3r.bakalarka.bakalarka;

import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import com.google.zxing.integration.android.IntentIntegrator;
import com.google.zxing.integration.android.IntentResult;

public class MainActivity extends AppCompatActivity {

    private Configuration configuration;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        JNILib.createFile();
        super.onCreate(savedInstanceState);
        this.configuration = new Configuration(this.getApplicationContext());
        setContentView(R.layout.activity_main);
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    public void doRegister(View view) {
//        Log.d("Register", "Hello register");
        IntentIntegrator integrator = new IntentIntegrator(this);
        integrator.initiateScan();
    }

    public void startServer(View view) {
//        Log.d("StartServer", "Hello start server");
        Intent intent = new Intent(this, ServerService.class);
        intent.setAction(ServerService.STARTFOREGROUND_ACTION);
        startService(intent);
    }

    public void showPairedDevices(View view) {
        Intent intent = new Intent(this, PairedDevicesViewActivity.class);
        startActivity(intent);
    }

    public void onActivityResult(int requestCode, int resultCode, Intent intent) {
        IntentResult scanResult = IntentIntegrator.parseActivityResult(requestCode, resultCode, intent);
        if (scanResult != null) {
            String contents = scanResult.getContents();
//            Log.d("Scan Result", scanResult.toString());
//            Log.d("Contents", contents);
            String[] keypair = contents.split(" ");
            if (keypair.length != 2) {
                // something is wrong
            } else {
                String uuid = keypair[0];
                String key = keypair[1];
                configuration.storeSecretFor(uuid, key);
            }
        }
    }
}
