REQUIREMENTS
============

To compile these applications & library you need:

- CMake
- a compiler supporting C++11 and C99 designated initializers (example. clang)
- OpenSSL development libraries
- FUSE development libraries

To use the application you need:

- OpenSSL
- FUSE

To use pairing application you need in addition:

- QREncode http://fukuchi.org/works/qrencode/ (Should be installable from repositories
, tested on debian & fedora)

HOW TO COMPILE
==============

    export CC=/usr/bin/clang # set your compiler here
    export CXX=/usr/bin/clang++ # set your compiler here
    cmake .
    make -j8
    
HOW TO INSTALL
==============
    
    sudo make install

after compiling    

APPLICATION COMPONENTS
======================
libalc.so
---------
C++ library for communication using ALC protocol. Default implementation supports 
encryption by AES-128-CBC algorithm encoded to Base64, FUSE filesystem with
switchable root and getting the rotation vector of the connected phone.

androidfuse
-----------
FUSE filesystem for accessing files on the phone. Requires devices to be paired
and encryption to be active. Use `fusermount -u mountpoint/` to unmount mounted
filesystem.

phonefind
---------
Application used to find phones on the local area network you are connected to.

alcpair
-------
Generates an encryption key for target device, displays it in the form of a 
QR code and notifies the device.

HOW TO USE
==========
    androidfuse -i <IP address of phone> -t localmountpoint/ -s /remotemountpoint/ -p <phone communication port>

IP address and local mountpoint are required arguments. Remote mountpoint
defaults to primary external storage on the device (most likely internal
storage), port defaults to default ALC communication port (6000);

    phonefind

Phonefind is trying to find at least one device. If you want to interrupt
it, press Ctrl+C

    alcpair -i <IP address of phone> -p <port>

IP address is mandatory, port defaults to default ALC communication port (6000);