#ifndef ANDROIDFUSE_AES_CRYPTO_H
#define ANDROIDFUSE_AES_CRYPTO_H

#include <stdlib.h>
#include <string>

void init_crypto();
void destroy_crypto();
void handle_crypto_errors();

int generate_iv(unsigned char* iv);

int encrypt(unsigned char *plaintext, size_t plaintext_len, unsigned char *key, unsigned char *iv,
            unsigned char *ciphertext);

int decrypt(unsigned char *ciphertext, int ciphertext_len, unsigned char *key, unsigned char *iv,
            unsigned char *plaintext);

std::string encrypt_base64(unsigned char *plaintext, size_t plaintext_len, unsigned char *key, unsigned char *iv);
std::string encrypt_base64(unsigned char *plaintext, size_t plaintext_len, unsigned char *key);

int decrypt_base64(std::string ciphertext, unsigned char* key, unsigned char* plaintext);
int decrypt_base64(unsigned char *ciphertext, int ciphertext_len, unsigned char* key, unsigned char* plaintext);

#endif //ANDROIDFUSE_AES_CRYPTO_H
