#include <iostream>
#include "alc_config.h"
#include "libalc.h"
#include "aes_crypto.h"
#include "base64.h"
#include <stdlib.h>
#include <getopt.h>

using namespace std;

int main(int argc, char** argv) {
    char *ipvalue = NULL;
    int portvalue = 6000;
    int c;
    while ((c = getopt(argc, argv, "i:p:")) != -1) {
        switch(c) {
            case 'i':
                ipvalue = optarg;
                break;
            case 'p':
                portvalue = atoi(optarg);
                break;
            case '?':
                cerr << "Unknown argument -" << optopt << endl;
                break;
            default:
                exit(1);
        }
    }

    if (ipvalue == NULL) {
        cerr << "IP address is required!" << endl;
        cerr << "Usage: alcpair -i <IP address> -p <port>" << endl << endl;
    }

    string uuid = alc_uuid();
    LLS* lls = alc_connect(ipvalue, portvalue);
    string target_uuid = afs_identify_phone(lls);
    unsigned char key[16];
    generate_iv(key);
    string key_b64 = base64_encode(key, 16);
    string qr_content = uuid + " " + key_b64;
    add_keypair(target_uuid, key_b64);
    string invocation = "qrencode -t ANSI \"" + qr_content + "\"";
    system(invocation.c_str());
    alc_pair(lls);
    cout << "This device ID is: " + uuid << endl;
    cout << "Pairing with phone with ID: " + target_uuid << endl;
    alc_disconnect(lls);
    return 0;
}