#include <iostream>
#include <netinet/in.h>
#include <assert.h>
#include <string.h>
#include <set>
#include <arpa/inet.h>
#include "alc_config.h"

using namespace std;

int main() {
    cout << "Waiting for at least 1 phone.... Press Ctrl+C to interrupt\n";
    sockaddr_in si_me, si_other;
    int s;
    assert((s=socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP))!=-1);
    int port=9247;
    int broadcast=1;

    setsockopt(s, SOL_SOCKET, SO_BROADCAST,
               &broadcast, sizeof broadcast);

    memset(&si_me, 0, sizeof(si_me));
    si_me.sin_family = AF_INET;
    si_me.sin_port = htons(port);
    si_me.sin_addr.s_addr = INADDR_ANY;

    assert(::bind(s, (sockaddr *)&si_me, sizeof(sockaddr))!=-1);

    time_t start = time(NULL);
    set<pair<string, string> > found;
    while(1)
    {
        char buf[10000];
        unsigned slen=sizeof(sockaddr);
        int ret = recvfrom(s, buf, sizeof(buf)-1, 0, (sockaddr *)&si_other, &slen);
        buf[ret] = 0;
        char* ip = inet_ntoa(si_other.sin_addr);
        string ip_str(ip);
        string str(buf, ret);
        string test = str.substr(0, 3);
        if (test != "ALC") {
            cout << "Invalid broadcast\n";
        } else {
            string uuid = str.substr(4);
            found.insert(make_pair(uuid, ip_str));
        }
        time_t current = time(NULL);
        if (current - start >= 5) {
            break;
        }
    }
    cout << "Found devices: " << endl;
    for (pair<string, string> device : found) {
        string uuid = device.first;
        string ip_addr = device.second;
        cout << ip_addr << " " << uuid << (has_key_for(uuid) ? " PAIRED" : " ") << endl;
    }
}