#define FUSE_USE_VERSION 30
#ifndef ANDROIDFUSE_FUSE_IMPL_H
#define ANDROIDFUSE_FUSE_IMPL_H
#include <fuse.h>

int afs_open_fuse(const char *path, struct fuse_file_info *fi);
int afs_mkdir_fuse(const char *path, mode_t mode);
int afs_truncate_fuse(const char *path, off_t offset);
int afs_release_fuse(const char *path, struct fuse_file_info *fi);
int afs_fallocate_fuse(const char *path, int mode, off_t offset, off_t len, struct fuse_file_info *fi);
int afs_read_fuse(const char *path, char *buf, size_t size, off_t offset, struct fuse_file_info *fi);
int afs_write_fuse(const char *path, const char *buf, size_t size, off_t offset, struct fuse_file_info *fi);
int afs_create_fuse(const char *path, mode_t mode, struct fuse_file_info *fi);
int afs_unlink_fuse(const char *path);
int afs_rmdir_fuse(const char *path);
int afs_access_fuse(const char *path, int flags);
int afs_utimens_fuse(const char *path, const struct timespec tv[2]);
int afs_getattr_fuse(const char *path, struct stat *stbuf);
int afs_statfs_fuse(const char *path, struct statvfs *stbuf);
int afs_rename_fuse(const char *oldpath, const char *newpath);
int afs_readdir_fuse(const char *path, void *buf, fuse_fill_dir_t filler,
                            off_t offset, struct fuse_file_info *fi);

extern struct fuse_operations afs_oper;

#endif //ANDROIDFUSE_FUSE_IMPL_H
